package com.ruoyi.system.service.impl;

import java.util.List;

import com.ruoyi.common.core.domain.entity.SysUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.common.constant.UserConstants;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.system.domain.SysPost;
import com.ruoyi.system.mapper.SysPostMapper;
import com.ruoyi.system.mapper.SysUserPostMapper;
import com.ruoyi.system.service.ISysPostService;

/**
 * 岗位信息 服务层处理
 * 
 * @author ruoyi
 */
@Service
public class SysPostServiceImpl implements ISysPostService
{
    @Autowired
    private SysPostMapper postMapper;

    @Autowired
    private SysUserPostMapper userPostMapper;

    /**
     * 查询岗位信息集合
     * 
     * @param post 岗位信息
     * @return 岗位信息集合
     */
    @Override
    public List<SysPost> selectPostList(SysPost post)
    {
        return postMapper.selectPostList(post);
    }

    /**
     * 查询所有岗位
     * 
     * @return 岗位列表
     */
    @Override
    public List<SysPost> selectPostAll()
    {
        return postMapper.selectPostAll();
    }

    /**
     * 通过岗位ID查询岗位信息
     * 
     * @param postId 岗位ID
     * @return 角色对象信息
     */
    @Override
    public SysPost selectPostById(Long postId)
    {
        return postMapper.selectPostById(postId);
    }

    /**
     * 根据用户ID获取岗位选择框列表
     * 
     * @param userId 用户ID
     * @return 选中岗位ID列表
     */
    @Override
    public List<Long> selectPostListByUserId(Long userId)
    {
        return postMapper.selectPostListByUserId(userId);
    }

    /**
     * 校验岗位名称是否唯一
     * 
     * @param post 岗位信息
     * @return 结果
     */
    @Override
    public boolean checkPostNameUnique(SysPost post)
    {
        Long postId = StringUtils.isNull(post.getPostId()) ? -1L : post.getPostId();
        SysPost info = postMapper.checkPostNameUnique(post.getPostName());
        if (StringUtils.isNotNull(info) && info.getPostId().longValue() != postId.longValue())
        {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 校验岗位编码是否唯一
     * 
     * @param post 岗位信息
     * @return 结果
     */
    @Override
    public boolean checkPostCodeUnique(SysPost post)
    {
        Long postId = StringUtils.isNull(post.getPostId()) ? -1L : post.getPostId();
        SysPost info = postMapper.checkPostCodeUnique(post.getPostCode());
        if (StringUtils.isNotNull(info) && info.getPostId().longValue() != postId.longValue())
        {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    /**
     * 通过岗位ID查询岗位使用数量
     * 
     * @param postId 岗位ID
     * @return 结果
     */
    @Override
    public int countUserPostById(Long postId)
    {
        return userPostMapper.countUserPostById(postId);
    }

    /**
     * 删除岗位信息
     * 
     * @param postId 岗位ID
     * @return 结果
     */
    @Override
    public int deletePostById(Long postId)
    {
        return postMapper.deletePostById(postId);
    }

    /**
     * 批量删除岗位信息
     * 
     * @param postIds 需要删除的岗位ID
     * @return 结果
     */
    @Override
    public int deletePostByIds(Long[] postIds)
    {
        for (Long postId : postIds)
        {
            SysPost post = selectPostById(postId);
            if (countUserPostById(postId) > 0)
            {
                throw new ServiceException(String.format("%1$s已分配,不能删除", post.getPostName()));
            }
        }
        return postMapper.deletePostByIds(postIds);
    }

    /**
     * 新增保存岗位信息
     * 
     * @param post 岗位信息
     * @return 结果
     */
    @Override
    public int insertPost(SysPost post)
    {
        return postMapper.insertPost(post);
    }

    /**
     * 修改保存岗位信息
     * 
     * @param post 岗位信息
     * @return 结果
     */
    @Override
    public int updatePost(SysPost post)
    {
        return postMapper.updatePost(post);
    }

    /**
     * 查询高级管理员集合
     *
     * @param
     * @return 高级管理员列表
     */
    @Override
    public List<SysUser> selectGmAssistant(SysUser user) {
        return userPostMapper.selectGmAssistant(user);
    }

    /**
     * 查询经营主任集合
     *
     * @param
     * @return 经营主任列表
     */
    @Override
    public List<SysUser> selectJyLeader(SysUser user) {
        return userPostMapper.selectJyLeader(user);
    }

    /**
     * 查询董事会秘书集合
     *
     * @param
     * @return 董事会秘书列表
     */
    @Override
    public List<SysUser> selectDsSecretary(SysUser user) {
        return userPostMapper.selectDsSecretary(user);
    }

    /**
     * 根据岗位查询用户
     *
     * @param
     * @return 用户列表
     */
    @Override
    public List<SysUser> selectUserListByPostName(String postName) {
        return userPostMapper.selectUserListByPostName(postName);
    }

    /**
     * 查询子公司执行董事
     *
     * @param
     * @return 查询子公司执行董事
     */
    @Override
    public SysUser selectSubLeaderByUserId(String userId) {
        return userPostMapper.selectSubLeaderByUserId(userId);
    }

    /**
     * 查询子公司总经理
     *
     * @param
     * @return 查询子公司总经理
     */
    @Override
    public SysUser selectSubGmByUserId(String userId) {
        return userPostMapper.selectSubGmByUserId(userId);
    }

    /**
     * 查询分公司经理
     *
     * @param
     * @return 查询分公司经理
     */
    @Override
    public SysUser selectBranchLeaderByUserId(String userId) {
        return userPostMapper.selectBranchLeaderByUserId(userId);
    }

    /**
     * 查询部门主任
     *
     * @param
     * @return 查询部门主任
     */
    @Override
    public SysUser selectDeptLeaderByUserId(String userId) {
        return userPostMapper.selectDeptLeaderByUserId(userId);
    }

    /**
     * 查询部门主任
     *
     * @param
     * @return 查询部门主任
     */
    @Override
    public SysUser selectParentDeptLeaderByUserId(String userId) {
        return userPostMapper.selectParentDeptLeaderByUserId(userId);
    }

    /**
     * 查询部门副主任
     *
     * @param
     * @return 查询部门副主任
     */
    @Override
    public SysUser selectViceDeptLeaderByUserId(String userId) {
        return userPostMapper.selectViceDeptLeaderByUserId(userId);
    }

    /**
     * 查询子公司执行董事
     *
     * @param
     * @return 查询子公司执行董事
     */
    @Override
    public SysUser selectSubLeaderByDeptId(String deptId) {
        return userPostMapper.selectSubLeaderByDeptId(deptId);
    }

    /**
     * 查询子公司总经理
     *
     * @param
     * @return 查询子公司总经理
     */
    @Override
    public SysUser selectSubGmByDeptId(String deptId) {
        return userPostMapper.selectSubGmByDeptId(deptId);
    }

    /**
     * 查询分公司经理
     *
     * @param
     * @return 查询分公司经理
     */
    @Override
    public SysUser selectBranchLeaderByDeptId(String deptId) {
        return userPostMapper.selectBranchLeaderByDeptId(deptId);
    }

    /**
     * 查询部门主任
     *
     * @param
     * @return 查询部门主任
     */
    @Override
    public SysUser selectParentDeptLeaderByDeptId(String deptId) {
        return userPostMapper.selectParentDeptLeaderByDeptId(deptId);
    }

    /**
     * 查询部门主任
     *
     * @param
     * @return 查询部门主任
     */
    @Override
    public SysUser selectDeptLeaderByDeptId(String deptId) {
        return userPostMapper.selectDeptLeaderByDeptId(deptId);
    }

    /**
     * 查询部门主任
     *
     * @param
     * @return 查询部门主任
     */
    @Override
    public List<SysUser> selectDeptLeadersByDeptId(String deptId) {
        return userPostMapper.selectDeptLeadersByDeptId(deptId);
    }

    /**
     * 查询部门副主任
     *
     * @param
     * @return 查询部门副主任
     */
    @Override
    public SysUser selectViceDeptLeaderByDeptId(String deptId) {
        return userPostMapper.selectViceDeptLeaderByDeptId(deptId);
    }

    /**
     * 查询部门副主任列表
     *
     * @param
     * @return 查询部门副主任列表
     */
    @Override
    public List<SysUser> selectViceDeptLeaderListByDeptId(String deptId) {
        return userPostMapper.selectViceDeptLeaderListByDeptId(deptId);
    }
}
